%global commit0 e38a16da6fbd3f92c23c37fc28a4d0e00a9c0602
%global gittag0 0.23beta
%global shortcommit0 %(c=%{commit0}; echo ${c:0:7})

%global _hardened_build 1

Name:		msed
Version:	0.23
Release:	0.6.beta.git%{shortcommit0}%{?dist}
Summary:	Tools to manage the activation and use of self encrypting drives

License:	GPLv3+
URL:		http://www.r0m30.com/msed/
Source0:	https://github.com/r0m30/%{name}/archive/%{commit0}/%{name}-%{commit0}.tar.gz
# Fix for https://github.com/r0m30/msed/issues/22
Patch0:		msed-aligned_alloc-memalign.patch
# Patches to fix various compiler warnings,
# sent upstream: https://github.com/r0m30/msed/pull/28
Patch1:		msed-warnings-parens.patch
Patch2:		msed-warnings-static-const.patch
Patch3:		msed-warnings-virtual-dtor.patch
Patch4:		msed-warnings-gc-hmac.patch
# Patch to use nanosleep instead of the obsolete usleep,
# sent upstream: https://github.com/r0m30/msed/pull/28
Patch5:		msed-nanosleep.patch

BuildRequires:	ncurses-devel

%description
MSED is a Self-Encrypting Drive (SED) management program and Pre-Boot
Authorization (PBA) image that will allow the activation and use of
self encrypting drives that comply with the Trusted Computing Group
Opal 2.0 SSC.

This package provides the msed and linuxpba binaries, but not the PBA
image itself.

%prep
%setup -q -n msed-%{commit0}
%patch0 -p1 -b .memalign
%patch1 -p1 -b .parens
%patch2 -p1 -b .const
%patch3 -p1 -b .virtualdtor
%patch4 -p1 -b .gchmac
%patch5 -p1 -b .nanosleep
# Adjust the GitVersion.sh script to just use the git tag from the
# checkout so we don't need a full git tree or the git tool itself.
sed -i -e's/^GITVER=.*/GITVER=%{gittag0}/' GitVersion.sh


%build
# Always use the x86_64 build configuration, because we override
# CFLAGS etc. for each arch build anyway and the upstream makefiles
# don't have build configs for every arch we support.
make %{?_smp_mflags} CFLAGS="$RPM_OPT_FLAGS" CXXFLAGS="$RPM_OPT_FLAGS" CONF=Release_x86_64

cd LinuxPBA
make %{?_smp_mflags} CFLAGS="$RPM_OPT_FLAGS" CXXFLAGS="$RPM_OPT_FLAGS" CONF=Release


%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_bindir}
install -p -m755 dist/Release_x86_64/msed $RPM_BUILD_ROOT%{_bindir}/msed
install -p -m755 LinuxPBA/dist/Release/GNU-Linux-x86/linuxpba $RPM_BUILD_ROOT%{_bindir}/linuxpba


%files
%doc README.md msed/Copyright.txt msed/ReadMe.txt msed/linux/PSIDRevert_LINUX.txt
%license msed/LICENSE.txt
%{_bindir}/msed
%{_bindir}/linuxpba


%changelog
* Mon Jul 27 2015 Charles R. Anderson <cra@wpi.edu> - 0.23-0.6.beta.gite38a16d
- add comments about upstream pull requests for patches

* Sun Jul 26 2015 Charles R. Anderson <cra@wpi.edu> - 0.23-0.5.beta.gite38a16d
- use Github Source0 URL and standard macros for git hash
- patch GitVersion.sh to use a static git tag so we do not need a
  full git tree or the git tool for building.
- preserve timestamps of installed files

* Tue Jul 21 2015 Charles R. Anderson <cra@wpi.edu> - 0.23-0.4.beta.gite38a16d
- mark LICENSE.txt as a license text
- enable hardened build

* Tue Jul 21 2015 Charles R. Anderson <cra@wpi.edu> - 0.23-0.3.beta.gite38a16d
- add more documentation

* Tue Jul 21 2015 Charles R. Anderson <cra@wpi.edu> - 0.23-0.2.beta.gite38a16d
- add BR git to properly define GIT_VERSION 

* Mon Jul 20 2015 Charles R. Anderson <cra@wpi.edu> - 0.23-0.1.beta.gite38a16d
- initial package
